;;; A standard set of terrain types shared by many game designs.

(game-module "stdterr"
)

(terrain-type sea
  (extensions ((water true)))
  (color "sky blue") (image-name "sea") (char "."))
(terrain-type shallows
  (extensions ((water true)))
  (color "cyan") (image-name "shallows") (char ","))
(terrain-type swamp
  (color "yellow green") (image-name "swamp") (char "="))
(terrain-type desert
  (color "yellow") (image-name "desert") (char "~"))
(terrain-type plains
  (color "green") (image-name "plains") (char "+"))
(terrain-type forest
  (color "forest green") (image-name "forest") (char "%"))
(terrain-type mountains
  (color "sienna") (image-name "mountains") (char "^"))
(terrain-type ice
  (extensions ((water true)))
  (color "white") (image-name "ice") (char "_"))

(terrain-type road
  (color "gray") (char ">")
  (subtype connection)
  (extensions (road true)))

(terrain-type river
  (color "blue") (char "<")
  (subtype border)
  (extensions ((river true) (water true))))

(add (sea shallows) elevation-min 0)

(add (sea shallows) elevation-max 0)

;;; Some defns for the fractal percentile generator.

(set alt-blob-density 10000)
(set alt-blob-size 20)
(set alt-smoothing 6)
(set wet-blob-density 2000)
(set wet-blob-size 100)

(add t* alt-percentile-min (  0  0  0  20  20  20  93  99  0 0 0))
(add t* alt-percentile-max ( 20  0  0  93  93  93  99 100  0 0 0))
;(add t* alt-percentile-min (  0  68  69  70  70  70  93  99  0 0 0))
;(add t* alt-percentile-max ( 68  69  71  93  93  93  99 100  0 0 0))
(add t* wet-percentile-min (  0   0  50   0  20  80   0   0  0 0 0))
(add t* wet-percentile-max (100 100 100  20  80 100 100 100  0 0 0))

;;; River generation.

(add (plains forest mountains) river-chance (5000 10000 10000))

(set river-sink-terrain shallows)

;(table terrain-interaction (river (sea shallows) non-terrain))

;(add (sea shallows ice) extensions ((water true)))

;;; Road generation.

(table road-into-chance
  (t* plains 100)
  (plains (desert forest mountains) (50 40 20))
  )

(set edge-terrain ice)

; should declare that watery types moderate temp extremes.

;;; Any attempts to use t* in other files should be aware of
;;; how many types are defined in this file.

